'''

This addon protect your server from high ping players, works also for ping-hackers.

It adds a timer function (find it bottom)

You need srcds.console for this addon, works only on linux
'''

import es
import srcds.console
import playerlib

# for timer
import thread
import time
#

global pPing_debug
pPing_debug = 0

info = es.AddonInfo() 
info.name     = "pPing" 
info.version  = "1.3" 
info.url      = "http://addons.eventscripts.com/addons/view/pPing" 
info.author   = "Eun"
info.basename = "pPing"

global pPing_players
global pPing_t
global pPing_bufsize
pPing_bufsize = 2048
pPing_players = {}

es.server.cmd('es_xset pPing 1.3') 
es.makepublic("pPing")
es.server.cmd('es_xset pPing_maxping 150')

es.server.cmd('es_xset pPing_warnings 2')
es.server.cmd('es_xset pPing_interval 30')
 
es.server.cmd('es_xset pPing_warnmsg "Please lower your ping or you get kicked"')
es.server.cmd('es_xset pPing_kickmsg "Your ping was to high [Max: 150]"')
es.server.cmd('es_xset pPing_kickmsgpub "was kicked beacause of violating the ping limit (150)"')



def load():
	global pPing_players
	global pPing_t
	pPing_players = {}
	pdebug('[pPing] Loading...')
	
	pdebug('[pPing] Create alias')
	es.server.cmd('alias pPing_check es_xdoblock pPing/time_handle')
	
	pdebug('[pPing] Reading config')
	es.server.cmd('exec pPing.cfg')
	
	pdebug('[pPing] Calculate buffer size')
	calcbufsize()

	pdebug('[pPing] Getting online players')
	
	PlayerList = es.getUseridList()
	for userid in PlayerList:
		if not es.isbot(userid):		
			info = {}
			info['cnts'] = '0'
			pPing_players[userid] = info
			pdebug('[pPing] Added/Upgraded userid (' + str(userid) + ')')

	pdebug('[pPing] Initializing timer')
	pPing_t = Timer(es.ServerVar('pPing_interval'), time_handle)
	pPing_t.start()
	pdebug('[pPing] Timer started')
	pdebug('[pPing] Loaded')
	

def unload():
	global pPing_players
	global pPing_t
	pdebug('[pPing] Stopping timer')
	pPing_t.stop();
	pPing_players = {}
	pdebug('[pPing] Unloading')
	es.server.cmd('alias pPing_check es_load pPing')
 

def player_activate(e):
	global pPing_players
	if not es.isbot(e['userid']):		
		info = {}
		info['cnts'] = '0'
		pPing_players[int(e['userid'])] = info
		pdebug('[pPing] Added/Upgraded userid (' + e['userid'] + ')')
 
def player_disconnect(e):
	global pPing_players
	if not es.isbot(e['userid']):
		if (int(e['userid']) in pPing_players):
			info = {}
			info['cnts'] = '0'
			pPing_players[int(e['userid'])] = info
			pdebug('[pPing] Removed userid (' + e['userid'] + ')')

def es_map_start(e):
	global pPing_players
	pPing_players = {}
	pdebug('[pPing] Cleared userids')


def calcbufsize():
	global pPing_bufsize
	i = 10
	pPing_maxplayers = int(es.ServerVar('maxplayers'))
	pPing_bufsize = 2048
	for i in range(i, pPing_maxplayers,10):
		pPing_bufsize = pPing_bufsize + 1048
	pdebug('[pPing] Bufsize changed to ' + str(pPing_bufsize))
	
def get_server_info(callback):
	global pPing_bufsize
	srcds.console.get_concmd_output('status', status_callback, callback,None,pPing_bufsize)
 
def status_callback(text, callback):

	global pPing_players
	info = {}
	n = 0
	suserid = ''
	userid = 0
	lines = text.replace('\n','')
	lines = lines.split('#')
	i=2
	maxping = es.ServerVar('pPing_maxping')
	warnings = es.ServerVar('pPing_warnings')
	warnmsg = es.ServerVar('pPing_warnmsg')
	kickmsg = es.ServerVar('pPing_kickmsg')
	kickmsgpub = es.ServerVar('pPing_kickmsgpub')
	if (len(lines) > 2) :
		pdebug("[pPing] Geting players")
		pdebug("========================================================================================================")
		for i in range(i, len(lines)):
			n = n + 1
			line = lines[i]
			pdebug (line)
			
			line = line.split(' ')
			if (line[0] != ''): suserid = line[0]
			else:
				if (line[1] != ''): suserid = line[1]
				else: suserid = line[2]
			userid = int(suserid)
			
			if not es.isbot(userid) :
				ping = line[len(line) - 4]
				status = line[len(line) - 2]
				if (status == 'active'):
					if (userid in pPing_players):
						pdebug('[pPing] Checking ' + str(userid))
						if (int(ping) > int(maxping)):
							if (int(pPing_players[userid]['cnts']) >= int(warnings)):
								player = playerlib.getPlayer(userid)
								pdebug('[pPing] Kicking ' + str(userid))
								player.kick(kickmsg+";")
								
								if (kickmsgpub != ''):
									es.msg('#multi','#green[pPing] #lightgreen'+player.attributes['name']+' #green' + kickmsgpub)
							else:
								warnplayer(userid,warnmsg)
								pPing_players[userid]['cnts'] = int(pPing_players[userid]['cnts']) + 1;
								
		pdebug("========================================================================================================")	
	pdebug("Checked " + str(n) + " players")	
	callback(info)

def warnplayer(userid,warnmsg):
	pdebug('[pPing] warning ' + str(userid))
	es.tell(userid,'#multi','#green[pPing] #lightgreen' + warnmsg)
	es.server.cmd('es usermsg hudhint ' + str(userid) + ' "' + warnmsg + '"')
	es.server.cmd('es usermsg centermsg ' + str(userid) + ' "' + warnmsg + '"')
	

def nothin(info):
	# nothin to do here
	pdebug('[pPing] Pingcheck finished')
	
def time_handle():
	pdebug('[pPing] Start pingcheck')
	get_server_info(nothin)
	
def pdebug(text):
	global debug
	es.dbgmsg(1,text)
	if (pPing_debug == 1):
		print text

class Timer:

    # Create Timer Object
    def __init__(self, interval, function, *args, **kwargs):
        self.__lock = thread.allocate_lock()
        self.__interval = interval
        self.__function = function
        self.__args = args
        self.__kwargs = kwargs
        self.__loop = False
        self.__alive = False

    # Start Timer Object
    def start(self):
        self.__lock.acquire()
        if not self.__alive:
            self.__loop = True
            self.__alive = True
            thread.start_new_thread(self.__run, ())
        self.__lock.release()

    # Stop Timer Object
    def stop(self):
        self.__lock.acquire()
        self.__loop = False
        self.__lock.release()

    # Private Thread Function
    def __run(self):
        while self.__loop:
            self.__function(*self.__args, **self.__kwargs)
            time.sleep(self.__interval)
        self.__alive = False
